#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;

namespace HeuristicLab.Grammars {
  public class Sequence : ReadOnlyCollection<ISymbol> {
    public Sequence(IList<ISymbol> seq)
      : base(seq) {
    }

    public override bool Equals(object obj) {
      if (obj == this) return true;
      Sequence other = obj as Sequence;
      if (other == null || Count != other.Count) return false;
      return this.SequenceEqual(other);
    }

    public override int GetHashCode() {
      return this.Aggregate(0, (h, s) => h + s.GetHashCode());
    }

    public override string ToString() {
      return this.Aggregate("", (str, symb) => str + symb);
    }
  }
}
